<?php
/**
 * @author FiloBlu
 * @copyright Copyright (c) 2019 FiloBlu (https://filoblu.com)
 * Preference for Amasty Xnotify Grid Out Of Stock
 */


namespace FiloBlu\ExtAmastyXnotif\Block\Adminhtml\Form\Field;


use Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray;

/**
 * Class AdditionalColumn
 * @package FiloBlu\ExtAmastyXnotif\Block\Adminhtml\Form\Field
 */
class AdditionalColumn extends AbstractFieldArray
{


    protected function _prepareToRender()
    {

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $attributeFactory = $objectManager->create('\Magento\Catalog\Model\ResourceModel\Eav\Attribute');
        $catalog_attributes_coll = $attributeFactory->getCollection()
            ->addFieldToFilter(\Magento\Eav\Model\Entity\Attribute\Set::KEY_ENTITY_TYPE_ID, 4);
        $catalog_attributes = array();
        foreach ($catalog_attributes_coll as $attribute) {
            $catalog_attributes[$attribute->getAttributeCode()] = $attribute->getFrontendLabel() . " - ({$attribute->getAttributeCode()})";
        }
        $catalog_attributes_block = $this->getLayout()->createBlock('Magento\Framework\View\Element\Html\Select')
            ->setId($this->_getCellInputElementId('<%- _id %>','catalog_product_attribute'))
            ->setName($this->_getCellInputElementName('catalog_product_attribute'))
            ->setClass('select')
            ->setOptions($catalog_attributes);


        $this->addColumn('column_name', array(
            'label' => __('Column Name')
        ));

        $this->addColumn('catalog_product_attribute', array(
            'label' => __('Product Attribute'),
            'renderer' => $catalog_attributes_block
        ));


        $this->_addAfter = false;
        $this->_addButtonLabel = __('Add attribute');
    }

}
